package org.dromara.system.service;

import cn.hutool.core.lang.tree.Tree;
import org.dromara.system.domain.bo.SysAreaBo;
import org.dromara.system.domain.vo.SysAreaVo;

import java.util.List;

/**
 * 区域管理 服务层
 *
 * @author Lion Li
 */
public interface ISysAreaService {
    /**
     * 查询区域管理数据
     *
     * @param area 区域信息
     * @return 区域信息集合
     */
    List<SysAreaVo> selectAreaList(SysAreaBo area);

    /**
     * 查询区域树结构信息
     *
     * @param area 区域信息
     * @return 区域树信息集合
     */
    List<Tree<Long>> selectAreaTreeList(SysAreaBo area);

    /**
     * 构建前端所需要下拉树结构
     *
     * @param areas 区域列表
     * @return 下拉树结构列表
     */
    List<Tree<Long>> buildAreaTreeSelect(List<SysAreaVo> areas);

    /**
     * 根据角色ID查询区域树信息
     *
     * @param roleId 角色ID
     * @return 选中区域列表
     */
//    List<Long> selectAreaListByRoleId(Long roleId);

    /**
     * 根据区域ID查询信息
     *
     * @param areaId 区域ID
     * @return 区域信息
     */
    SysAreaVo selectAreaById(Long areaId);

    /**
     * 通过区域ID串查询区域
     *
     * @param areaIds 区域id串
     * @return 区域列表信息
     */
    List<SysAreaVo> selectAreaByIds(List<Long> areaIds);

    /**
     * 根据ID查询所有子区域数（正常状态）
     *
     * @param areaId 区域ID
     * @return 子区域数
     */
    long selectNormalChildrenAreaById(Long areaId);

    /**
     * 是否存在区域子节点
     *
     * @param areaId 区域ID
     * @return 结果
     */
    boolean hasChildByAreaId(Long areaId);

    /**
     * 查询区域是否存在用户
     *
     * @param areaId 区域ID
     * @return 结果 true 存在 false 不存在
     */
    boolean checkAreaExistUser(Long areaId);

    /**
     * 校验区域名称是否唯一
     *
     * @param area 区域信息
     * @return 结果
     */
    boolean checkAreaNameUnique(SysAreaBo area);

    /**
     * 校验区域是否有数据权限
     *
     * @param areaId 区域id
     */
    void checkAreaDataScope(Long areaId);

    /**
     * 新增保存区域信息
     *
     * @param bo 区域信息
     * @return 结果
     */
    int insertArea(SysAreaBo bo);

    /**
     * 修改保存区域信息
     *
     * @param bo 区域信息
     * @return 结果
     */
    int updateArea(SysAreaBo bo);

    /**
     * 删除区域管理信息
     *
     * @param areaId 区域ID
     * @return 结果
     */
    int deleteAreaById(Long areaId);
}
